#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int max_n = 100011;

int n, degree[max_n];
int comp[max_n], parent[max_n];
int used[max_n], sizes[max_n];

bool dfs(int v) {
    if (used[v] == 1) {
        return false;
    }
    if (used[v] == 2) {
        return true;
    }
    used[v] = 1;
    if (parent[v] != -1 && !dfs(parent[v])) {
        return false;
    }
    used[v] = 2;
    return true;
}

int readAndCheckAnswer(InStream& in) {
    string s = in.readLine();
    if (s != "Yes" && s != "No") {
        in.quitf(_wa, "First length must be equal to Yes/No.");
    }
    if (s == "No") {
        return -1;
    }
    int res = in.readInt(1, n);
    for (int i = 1; i <= n; ++i) {
        comp[i] = in.readInt(1, res, "comp_i");
        parent[i] = in.readInt(-1, n, "parent_i");
        if (parent[i] == 0) {
            in.quitf(_wa, "Parent[i] cann't be equal to -1");
        }
    }
    memset(used, 0, sizeof(used));
    for (int i = 1; i <= n; ++i) {
        if (!dfs(i)) {
            in.quitf(_wa, "Graph has a cycle");
        }
    }
    int cycle_len[max_n];
    memset(cycle_len, 0, sizeof(cycle_len));
    memset(sizes, 0, sizeof(sizes));
    for (int i = 1; i <= n; ++i) {
        if (parent[i] == -1) {
            sizes[i] += 2;
            cycle_len[comp[i]] += 1;
        } else {
            ++sizes[i];
            ++sizes[parent[i]];
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (sizes[i] != degree[i]) {
            in.quitf(_wa, "Degree of vertex %d is equal to %d, not %d", i, sizes[i], degree[i]);
        }
        if (parent[i] != -1 && comp[parent[i]] != comp[i]) {
            in.quitf(_wa, "Edge %d -> %d connects vertex from two different components", i, parent[i]);
        }
    }
    for (int i = 1; i <= res; ++i) {
        if (cycle_len[i] < 3) {
            in.quitf(_wa, "Component %d don't have enough vertices on the cycle: %d < 3", i, cycle_len[i]);
        }
    }
    return res;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for (int i = 1; i <= n; ++i) {
        degree[i] = inf.readInt();
    }
    const int maximize = inf.readInt(0, 1);

    int jury_c = readAndCheckAnswer(ans);
    int participant_c = readAndCheckAnswer(ouf);
    if (participant_c == -1 && jury_c != -1) {
        quitf(_wa, "Jury find the answer while the participant don't");
    } else if (participant_c != -1 && jury_c == -1) {
        quitf(_fail, "Participant find the answer while the jury don't");
    }
    if (maximize) {
        if (jury_c > participant_c) {
            quitf(_wa, "Jury has more octopuses than participant: %d > %d", jury_c, participant_c);
        } else if (jury_c < participant_c) {
            quitf(_fail, "Jury has less octopuses than participant: %d < %d", jury_c, participant_c);
        }
    }
    quitf(_ok, "%s", validator.group().c_str());
    //quitf(_ok, "Ok, number of octopuses is equal to %d", participant_c);
}
